searchData={"items":[{"type":"module","title":"doctest","doc":null,"ref":"doctest.html"},{"type":"function","title":"doctest.module/1","doc":null,"ref":"doctest.html#module/1"},{"type":"function","title":"doctest.module/2","doc":null,"ref":"doctest.html#module/2"},{"type":"type","title":"doctest.options/0","doc":null,"ref":"doctest.html#t:options/0"},{"type":"type","title":"doctest.result/0","doc":null,"ref":"doctest.html#t:result/0"},{"type":"module","title":"doctest_eunit","doc":null,"ref":"doctest_eunit.html"},{"type":"function","title":"doctest_eunit.doc_tests/6","doc":null,"ref":"doctest_eunit.html#doc_tests/6"},{"type":"function","title":"doctest_eunit.moduledoc_tests/6","doc":null,"ref":"doctest_eunit.html#moduledoc_tests/6"},{"type":"function","title":"doctest_eunit.test/2","doc":null,"ref":"doctest_eunit.html#test/2"},{"type":"function","title":"doctest_eunit.test_title/2","doc":null,"ref":"doctest_eunit.html#test_title/2"},{"type":"module","title":"doctest_eunit_report","doc":null,"ref":"doctest_eunit_report.html"},{"type":"function","title":"doctest_eunit_report.handle_begin/3","doc":null,"ref":"doctest_eunit_report.html#handle_begin/3"},{"type":"function","title":"doctest_eunit_report.handle_cancel/3","doc":null,"ref":"doctest_eunit_report.html#handle_cancel/3"},{"type":"function","title":"doctest_eunit_report.handle_end/3","doc":null,"ref":"doctest_eunit_report.html#handle_end/3"},{"type":"function","title":"doctest_eunit_report.init/1","doc":null,"ref":"doctest_eunit_report.html#init/1"},{"type":"function","title":"doctest_eunit_report.start/0","doc":null,"ref":"doctest_eunit_report.html#start/0"},{"type":"function","title":"doctest_eunit_report.start/1","doc":null,"ref":"doctest_eunit_report.html#start/1"},{"type":"function","title":"doctest_eunit_report.terminate/2","doc":null,"ref":"doctest_eunit_report.html#terminate/2"},{"type":"behaviour","title":"doctest_extract","doc":null,"ref":"doctest_extract.html"},{"type":"callback","title":"doctest_extract.chunks/1","doc":null,"ref":"doctest_extract.html#c:chunks/1"},{"type":"callback","title":"doctest_extract.code_blocks/1","doc":null,"ref":"doctest_extract.html#c:code_blocks/1"},{"type":"function","title":"doctest_extract.code_blocks/2","doc":null,"ref":"doctest_extract.html#code_blocks/2"},{"type":"function","title":"doctest_extract.module_tests/2","doc":null,"ref":"doctest_extract.html#module_tests/2"},{"type":"type","title":"doctest_extract.chunk/0","doc":null,"ref":"doctest_extract.html#t:chunk/0"},{"type":"type","title":"doctest_extract.code_blocks/0","doc":null,"ref":"doctest_extract.html#t:code_blocks/0"},{"type":"type","title":"doctest_extract.doc_token/0","doc":null,"ref":"doctest_extract.html#t:doc_token/0"},{"type":"type","title":"doctest_extract.location/0","doc":null,"ref":"doctest_extract.html#t:location/0"},{"type":"type","title":"doctest_extract.moduledoc_token/0","doc":null,"ref":"doctest_extract.html#t:moduledoc_token/0"},{"type":"type","title":"doctest_extract.token/0","doc":null,"ref":"doctest_extract.html#t:token/0"},{"type":"module","title":"doctest_extract_attr","doc":null,"ref":"doctest_extract_attr.html"},{"type":"function","title":"doctest_extract_attr.chunks/1","doc":null,"ref":"doctest_extract_attr.html#chunks/1"},{"type":"function","title":"doctest_extract_attr.code_blocks/1","doc":null,"ref":"doctest_extract_attr.html#code_blocks/1"},{"type":"module","title":"doctest_extract_tag","doc":null,"ref":"doctest_extract_tag.html"},{"type":"function","title":"doctest_extract_tag.chunks/1","doc":null,"ref":"doctest_extract_tag.html#chunks/1"},{"type":"function","title":"doctest_extract_tag.code_blocks/1","doc":null,"ref":"doctest_extract_tag.html#code_blocks/1"},{"type":"module","title":"doctest_term","doc":null,"ref":"doctest_term.html"},{"type":"function","title":"doctest_term.format/1","doc":null,"ref":"doctest_term.html#format/1"},{"type":"function","title":"doctest_term.write/1","doc":null,"ref":"doctest_term.html#write/1"},{"type":"extras","title":"Overview","doc":"# doctest\n\nAn Erlang library to test `@doc` tags and `-moduledoc` and `-doc` attributes.\n\nIt is compatible with the [doctests syntax introduced in OTP-28](https://github.com/erlang/otp/pull/9315).\n\n> [!NOTE]\n>\n> The `-moduledoc` and `-doc` attributes were introduced in [OTP 27](https://www.erlang.org/docs/27/system/documentation).","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"```erlang\n% rebar.config\n% {minimum_otp_vsn, \"24\"}.\n{profiles, [\n    {test, [\n        % 'debug_info' is required to extract doc chunks.\n        {erl_opts, [debug_info]},\n        {deps, [{doctest, \"~> 0.13\"}]}\n    ]}\n]}.\n% 'doctest_eunit_report' is required to pretty print and correctly displays the failed Eunit tests.\n{eunit_opts, [no_tty, {report, {doctest_eunit_report, []}}]}.\n```\n\n> [!IMPORTANT]\n>\n> `doctest` won't run any test when `cover` is enabled, for example:\n>\n> ```erlang\n> {profiles, [\n>     {test, [\n>         {cover_enabled, true},\n>         % ...\n>     ]}\n> ]}.\n> ```\n>\n> There is an open [PR](https://github.com/erlang/otp/pull/9433) to fix this bug in the OTP repository.","ref":"readme.html#installation"},{"type":"extras","title":"Overview - Overview","doc":"Erlang documentation can be written:\n\n- Via [EDoc](https://www.erlang.org/doc/apps/edoc/chapter) by using the `@doc` tag, e.g.:\n\n  ````erlang\n  %% @doc Prints \"Hello, Joe!\".\n  %%\n  %% Example:\n  %%\n  %% ```\n  %% > print().\n  %% \"Hello, Joe!\"\n  %% '''\n  print() -> \"Hello, Joe!\".\n  ````\n\n- Or via [ExDoc](https://hexdocs.pm/ex_doc/readme.html), by using the `-moduledoc` and\n`-doc` attributes [introduced in OTP 27](https://www.erlang.org/doc/system/documentation), e.g.:\n\n  ````erlang\n  -doc \"\"\"\n  Prints \"Hello, Joe!\".\n\n  Example:\n\n  ```\n  > print().\n  \"Hello, Joe!\"\n  ```\n  \"\"\".\n  print() -> \"Hello, Joe!\".\n  ````\n\nThere are some rules to test documentation. One rule is that only code blocks\nare testable. Via `EDoc/tags`, code blocks are code between ` ``` ` and `'''`\n(triple backticks and triple single quotes), and via `ExDoc/attributes`,\nthey are code between ` ``` ` and ` ``` ` (triple quotes and triple quotes).\nThe code of the code blocks follows the same rules as the current Erlang shell, for example:\n\n```erlang\n> % - Comments and multiline expressions are allowed;\n  % - Multiline expressions must be aligned;\n  % - Invalid syntaxes are skipped.\n  print().\n\"Hello, Joe!\"\n> % All tests compare the equality between the expression and the result.\n  % The example below is translated to an `?assertEqual` macro result:\n  % > ?assertEqual(true, print() =/= \"Hello, World\").\n  print() =/= \"Hello, World!\".\ntrue\n```","ref":"readme.html#overview"},{"type":"extras","title":"Optionally - Overview","doc":"1. Variable outputs can be skipped by replacing the right side (result) by an\n   underscore (`_`) or without giving a result to it by starting a new expression\n2. The `erlang` language in code blocks is not required\n3. The syntax can contains the line numbers and dots between multiple lines,\n   like in the erlang shell\n\nFor example:\n\n````erlang\n-doc \"\"\"\n```erlang\n1> A =\n.. 1.\n_\n2> B = 1. % It's not required to show the result\n3> A + B.\n2\n```\n\"\"\".\nfoo(Foo) -> Foo.\n````","ref":"readme.html#optionally"},{"type":"extras","title":"Usage - Overview","doc":"````erlang\n-module(mymodule).\n-export([sum/2]).\n\n-ifdef(TEST).\n-include_lib(\"eunit/include/eunit.hrl\").\n\n% The EUnit header will automatically export this function because it ends with \"_test\"\ndoctest_test() ->\n    doctest:module(?MODULE, #{\n        % Default options:\n\n        % Enable or turn off module doc tests.\n        % Spec: boolean()\n        moduledoc => true,\n\n        % Enable or turn off functions doc tests or define a list of functions to be tested.\n        % Spec: boolean() | [{atom(), arity()}].\n        doc => true,\n\n        % Set the EUnit options. 'rebar3_config' tries to resolve the options defined in the rebar3.\n        % Spec: rebar3_config | [term()]\n        eunit_opts => rebar3_config,\n\n        % Overrides the code blocks extractors. See the 'doctest_extract' behavior.\n        % Custom extractors are allowed.\n        % Spec: [module()]\n        extractors => [doctest_extract_attr], % OTP < 27 => [doctest_extract_tag]\n\n        % Bind value to variables. Could be a proplist or a map.\n        % Spec: erl_eval:binding_struct()\n        bindings => #{},\n\n        % Define records to be expanded/compiled to tuple expressions.\n        % Spec: [{Name :: atom(), Fields :: [atom()]}]\n        % Example: [{RecName, record_info(fields, RecName)}]\n        records => []\n    }).\n-endif.\n\n% The `sum/2` will be tested by default because it contains a valid Markdown\n% code block. Multiple Markdown code blocks can be defined.\n-doc \"\"\"\n```\n> mymodule:sum(1, 1).\n2\n```\n\"\"\".\nsum(A, B) ->\n    A + B.\n````\n\n> [!NOTE]\n>\n> Please see the [rebar documentation](https://rebar3.org/docs/testing/eunit/#eunit_opts)\n> for more information about the EUnit options.","ref":"readme.html#usage"},{"type":"extras","title":"Example - Overview","doc":"> [!IMPORTANT]\n>\n> If the OTP version is below 27, please only consider the `@doc` tags inside comments as a valid code.\n> The `-moduledoc` and `-doc` attributes are valid if the OTP version is equal to or above 27.\n\nTake this module:\n\n````erlang\n 1 │ -module(greeting).\n 2 │ -moduledoc \"\"\"\n 3 │ Module documentation are testable.\n 4 │\n 5 │ ```\n 6 │ > greeting:print() =:= \"Hello, Joe!\".\n 7 │ true\n 8 │ ```\n 9 │ \"\"\".\n10 │\n11 │ -export([print/0]).\n12 │\n13 │ -ifdef(TEST).\n14 │ -include_lib(\"eunit/include/eunit.hrl\").\n15 │  doctest_test() ->\n16 │      doctest:module(?MODULE).\n17 │ -endif.\n18 │\n19 │ -doc \"\"\"\n20 │ ```\n21 │ > greeting:print().\n22 │ \"Hello, World!\"\n23 │ ```\n24 │ \"\"\".\n25 │ print() ->\n26 │     \"Hello, Joe!\".\n````\n\nRunning the EUnit test via rebar3:\n\n```bash\n$ rebar3 eunit --module greeting\n===> Verifying dependencies...\n===> Analyzing applications...\n===> Compiling doctest\n===> Performing EUnit tests...\n PASS  ./src/greeting.erl:6 -moduledoc\n FAIL  ./src/greeting.erl:21 -doc\n\n ❌ assertEqual\n\n    │\n 21 │ > greeting:print().\n 22 │ \"Hello, World!\"\n    │\n    └── at ./src/greeting.erl:21\n\nExpected:\n\"Hello, World!\"\n\nReceived:\n\"Hello, Joe!\"\n\n\n\nTests: 1 failed, 1 passed, 2 total\n Time: 0.003 seconds\n\n\n\n\nTests: 1 passed, 1 total\n Time: 0.0 seconds\n```\n\n> [!NOTE]\n>\n> The output above is by using the `doctest_eunit_report` as the EUnit report.\n\nIt is fine to put the `doctest_test` function in a Common Test module, for example:\n\n```erlang\n-module(greeting_SUITE).\n-ifdef(TEST).\n-include_lib(\"eunit/include/eunit.hrl\").\n doctest_test() ->\n     doctest:module(greeting).\n-endif.\n```\n\n> [!NOTE]\n>\n> The `doctest_test` function name could be any name of your choice.","ref":"readme.html#example"},{"type":"extras","title":"Doctest EUnit Reporter - Overview","doc":"There is a built-in EUnit reporter called `doctest_eunit_report` to display the\ntests results correctly. Set it in the EUnit options of the project options, e.g.:\n\n```erlang\n% rebar3.config\n{eunit_opts, [\n    no_tty,\n    {report, {doctest_eunit_report, [\n        % Default options\n\n        % Change the default depth of the output result.\n        % Spec: pos_integer()\n        {print_depth, 15}\n    ]}}\n]}.\n```\n\nAn example of the `doctest_eunit_report` output:\n![doctest_eunit_report](/assets/reporter-go-to-definition.gif)","ref":"readme.html#doctest-eunit-reporter"},{"type":"extras","title":"Sponsors - Overview","doc":"If you like this tool, please consider [sponsoring me](https://github.com/sponsors/williamthome).\nI'm thankful for your never-ending support :heart:\n\nI also accept coffees :coffee:\n\n[![\"Buy Me A Coffee\"](https://www.buymeacoffee.com/assets/img/custom_images/orange_img.png)](https://www.buymeacoffee.com/williamthome)","ref":"readme.html#sponsors"},{"type":"extras","title":"Contributing - Overview","doc":"","ref":"readme.html#contributing"},{"type":"extras","title":"Issues - Overview","doc":"Feel free to [submit an issue on Github](https://github.com/williamthome/doctest/issues/new).","ref":"readme.html#issues"},{"type":"extras","title":"License - Overview","doc":"Copyright (c) 2024 [William Fank Thomé](https://github.com/williamthome)\n\n`doctest` is 100% open source and community-driven. All components are available under the Apache 2 License on [GitHub](https://github.com/williamthome/doctest).\n\nSee [LICENSE.md](LICENSE.md) for more information.","ref":"readme.html#license"},{"type":"extras","title":"License","doc":"# Apache License\n\nVersion 2.0, January 2004\n\n \n\nTERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION","ref":"license.html"},{"type":"extras","title":"1. Definitions - License","doc":"\"License\" shall mean the terms and conditions for use, reproduction, and\ndistribution as defined by Sections 1 through 9 of this document.\n\n\"Licensor\" shall mean the copyright owner or entity authorized by the copyright\nowner that is granting the License.\n\n\"Legal Entity\" shall mean the union of the acting entity and all other entities\nthat control, are controlled by, or are under common control with that entity.\nFor the purposes of this definition, \"control\" means (i) the power, direct or\nindirect, to cause the direction or management of such entity, whether by\ncontract or otherwise, or (ii) ownership of fifty percent (50%) or more of the\noutstanding shares, or (iii) beneficial ownership of such entity.\n\n\"You\" (or \"Your\") shall mean an individual or Legal Entity exercising\npermissions granted by this License.\n\n\"Source\" form shall mean the preferred form for making modifications, including\nbut not limited to software source code, documentation source, and configuration\nfiles.\n\n\"Object\" form shall mean any form resulting from mechanical transformation or\ntranslation of a Source form, including but not limited to compiled object code,\ngenerated documentation, and conversions to other media types.\n\n\"Work\" shall mean the work of authorship, whether in Source or Object form, made\navailable under the License, as indicated by a copyright notice that is included\nin or attached to the work (an example is provided in the Appendix below).\n\n\"Derivative Works\" shall mean any work, whether in Source or Object form, that\nis based on (or derived from) the Work and for which the editorial revisions,\nannotations, elaborations, or other modifications represent, as a whole, an\noriginal work of authorship. For the purposes of this License, Derivative Works\nshall not include works that remain separable from, or merely link (or bind by\nname) to the interfaces of, the Work and Derivative Works thereof.\n\n\"Contribution\" shall mean any work of authorship, including the original version\nof the Work and any modifications or additions to that Work or Derivative Works\nthereof, that is intentionally submitted to Licensor for inclusion in the Work\nby the copyright owner or by an individual or Legal Entity authorized to submit\non behalf of the copyright owner. For the purposes of this definition,\n\"submitted\" means any form of electronic, verbal, or written communication sent\nto the Licensor or its representatives, including but not limited to\ncommunication on electronic mailing lists, source code control systems, and\nissue tracking systems that are managed by, or on behalf of, the Licensor for\nthe purpose of discussing and improving the Work, but excluding communication\nthat is conspicuously marked or otherwise designated in writing by the copyright\nowner as \"Not a Contribution.\"\n\n\"Contributor\" shall mean Licensor and any individual or Legal Entity on behalf\nof whom a Contribution has been received by Licensor and subsequently\nincorporated within the Work.","ref":"license.html#1-definitions"},{"type":"extras","title":"2. Grant of Copyright License - License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable copyright license to reproduce, prepare Derivative Works of,\npublicly display, publicly perform, sublicense, and distribute the Work and such\nDerivative Works in Source or Object form.","ref":"license.html#2-grant-of-copyright-license"},{"type":"extras","title":"3. Grant of Patent License - License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable (except as stated in this section) patent license to make, have\nmade, use, offer to sell, sell, import, and otherwise transfer the Work, where\nsuch license applies only to those patent claims licensable by such Contributor\nthat are necessarily infringed by their Contribution(s) alone or by combination\nof their Contribution(s) with the Work to which such Contribution(s) was\nsubmitted. If You institute patent litigation against any entity (including a\ncross-claim or counterclaim in a lawsuit) alleging that the Work or a\nContribution incorporated within the Work constitutes direct or contributory\npatent infringement, then any patent licenses granted to You under this License\nfor that Work shall terminate as of the date such litigation is filed.","ref":"license.html#3-grant-of-patent-license"},{"type":"extras","title":"4. Redistribution - License","doc":"You may reproduce and distribute copies of the Work or Derivative Works thereof\nin any medium, with or without modifications, and in Source or Object form,\nprovided that You meet the following conditions:\n\n1. You must give any other recipients of the Work or Derivative Works a copy of\n   this License; and\n\n2. You must cause any modified files to carry prominent notices stating that\n   You changed the files; and\n\n3. You must retain, in the Source form of any Derivative Works that You\n   distribute, all copyright, patent, trademark, and attribution notices from\n   the Source form of the Work, excluding those notices that do not pertain to\n   any part of the Derivative Works; and\n\n4. If the Work includes a \"NOTICE\" text file as part of its distribution, then\n   any Derivative Works that You distribute must include a readable copy of the\n   attribution notices contained within such NOTICE file, excluding those\n   notices that do not pertain to any part of the Derivative Works, in at least\n   one of the following places: within a NOTICE text file distributed as part\n   of the Derivative Works; within the Source form or documentation, if\n   provided along with the Derivative Works; or, within a display generated by\n   the Derivative Works, if and wherever such third-party notices normally\n   appear. The contents of the NOTICE file are for informational purposes only\n   and do not modify the License. You may add Your own attribution notices\n   within Derivative Works that You distribute, alongside or as an addendum to\n   the NOTICE text from the Work, provided that such additional attribution\n   notices cannot be construed as modifying the License.\n\nYou may add Your own copyright statement to Your modifications and may provide\nadditional or different license terms and conditions for use, reproduction, or\ndistribution of Your modifications, or for any such Derivative Works as a whole,\nprovided Your use, reproduction, and distribution of the Work otherwise complies\nwith the conditions stated in this License.","ref":"license.html#4-redistribution"},{"type":"extras","title":"5. Submission of Contributions - License","doc":"Unless You explicitly state otherwise, any Contribution intentionally submitted\nfor inclusion in the Work by You to the Licensor shall be under the terms and\nconditions of this License, without any additional terms or conditions.\nNotwithstanding the above, nothing herein shall supersede or modify the terms of\nany separate license agreement you may have executed with Licensor regarding\nsuch Contributions.","ref":"license.html#5-submission-of-contributions"},{"type":"extras","title":"6. Trademarks - License","doc":"This License does not grant permission to use the trade names, trademarks,\nservice marks, or product names of the Licensor, except as required for\nreasonable and customary use in describing the origin of the Work and\nreproducing the content of the NOTICE file.","ref":"license.html#6-trademarks"},{"type":"extras","title":"7. Disclaimer of Warranty - License","doc":"Unless required by applicable law or agreed to in writing, Licensor provides the\nWork (and each Contributor provides its Contributions) on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied,\nincluding, without limitation, any warranties or conditions of TITLE, NON-\nINFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are\nsolely responsible for determining the appropriateness of using or\nredistributing the Work and assume any risks associated with Your exercise of\npermissions under this License.","ref":"license.html#7-disclaimer-of-warranty"},{"type":"extras","title":"8. Limitation of Liability - License","doc":"In no event and under no legal theory, whether in tort (including negligence),\ncontract, or otherwise, unless required by applicable law (such as deliberate\nand grossly negligent acts) or agreed to in writing, shall any Contributor be\nliable to You for damages, including any direct, indirect, special, incidental,\nor consequential damages of any character arising as a result of this License or\nout of the use or inability to use the Work (including but not limited to\ndamages for loss of goodwill, work stoppage, computer failure or malfunction, or\nany and all other commercial damages or losses), even if such Contributor has\nbeen advised of the possibility of such damages.","ref":"license.html#8-limitation-of-liability"},{"type":"extras","title":"9. Accepting Warranty or Additional Liability - License","doc":"While redistributing the Work or Derivative Works thereof, You may choose to\noffer, and charge a fee for, acceptance of support, warranty, indemnity, or\nother liability obligations and/or rights consistent with this License. However,\nin accepting such obligations, You may act only on Your own behalf and on Your\nsole responsibility, not on behalf of any other Contributor, and only if You\nagree to indemnify, defend, and hold each Contributor harmless for any liability\nincurred by, or claims asserted against, such Contributor by reason of your\naccepting any such warranty or additional liability.\n\nEND OF TERMS AND CONDITIONS\n\nCopyright 2024-2025, William Fank Thomé  .\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n \n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"license.html#9-accepting-warranty-or-additional-liability"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}